/**
@author Cesar Vasquez & Nadia Herrera
@version 2.0 16-11-05
*/
package src.cliente;

import java.io.*;
import java.net.*;


/**
Programa cliente encargado de hacer la prueba
para el servidor.
*/
public class Cliente
{
   Socket servidor;
   InputStream entrada_red;
   OutputStream salida_red;


   /**
   Metodo principal, encargado de "echar a andar" el cliente
   de prueba. Los argumentos son los siguientes:<BR>
   client [HOST] [PUERTO] [NUMERO]<BR>
   @param args argumentos de entrada al programa. (ver mas arriba)
   */
   public static void main(String args[])
   {
      if (args.length == 3)
      {
         new Cliente(args[0], args[1], args[2]);

      }
      else
      {
         System.out.println("Uso: java Cliente [HOST] [PUERTO] [NUMERO]");
         System.exit(0);
      }
   }

   /**
   Constructor de la clase.
   @param host Direccion del servidor.
   @param port Puerto del servidor
   @param numero Numero que se desea procesar
   */
   public Cliente(String host, String port, String numero)
   {
      try
      {
         System.out.println("Cliente: conectando al host: " + host + ":" + port);

         servidor = new Socket(host, Integer.parseInt(port));
         entrada_red = servidor.getInputStream();
         salida_red = servidor.getOutputStream();

         salida_red.write(numero.getBytes());

         byte[] b = new byte[10];
         entrada_red.read(b);

         System.out.println("Cliente: numero = " + numero);
         System.out.println("Cliente: suma = " + new String(b));
      }
      catch (IOException e)
      {
         System.out.println("Ha ocurrido una excepcion no esperada...");
         e.printStackTrace();
      }
   }
}