/**
@author Cesar Vasquez & Nadia Herrera
@version 2.0 16-11-05
*/

package src.servidor;

import java.io.*;
import java.net.*;

/**
Clase Servidor. Esta clase se encarga de representar un servidor
que atendera consultas via TCP/IP para luego realizar una serie
de procesos, y devolver una respuesta al cliente.
*/
public class Servidor
{
   /**
   Constructor de la clase. Actualmente, no hace nada...
   */
   public Servidor()
   {
   
   }
   
   /**
   Metodo estatico Main, qui comienza la ejecucion del programa servidor.<BR>
   Los parametros de entrada son:<BR>
   java Servidor [PUERTO]
   @param args Arreglo con los parametros de entrada (ver mas arriba)
   */
   public static void main(String args[])
   {
      try
      {
         if(args.length != 1)
         {
            System.out.println("debe ingresar un puerto... ");
            System.out.println("uso:\t java Servidor [PUERTO]");
            System.exit(0);
         }


         int port = Integer.parseInt(args[0]);
         ServerSocket ss = new ServerSocket( port );   // ServerSocket que escucha el puerto
         Tabla tabla = new Tabla();

         System.out.println("ThreadServer: Esperando Conexiones... ");
         System.out.println("*********************************************");
         while(true)
         {
            Socket socket = ss.accept( );   // acepta la conexion al realizarse
            Hilos h = new Hilos(socket, tabla);
            Thread t = new Thread(h);
            t.start();     // inicializa este nuevo Thread
         }
      }
      catch (Exception e)
      {
         System.out.println("Ha ocurrido una excepcion no esperada...");
         e.printStackTrace();
      }
    }



}
